Subject: Re: [PATCH] sound: soc: fsl: Do not set DAI sysclk when it is equal to system freq

From: Nicolin Chen <[email-masked]>
Date: Wed, 6 Sep 2017 10:33:50 -0700

On Wed, Sep 06, 2017 at 11:22:48AM +0200, Łukasz Majewski wrote:

> >Here is the routine that I understood from the code:
> >1) asoc_simple_card_parse_clk_cpu(dev, cpu, dai_link, cpu_dai);
> >    => asoc_simple_card_parse_clk(dev, cpu,        // cpu node in sound{} [1]
> >		   		 dai_link->cpu_of_node,     // node ssi2 [2]
> >				 cpu_dai, dai_link->cpu_dai_name);
> >    ==> 1.1) devm_get_clk_from_child(dev, node, NULL);                 // [1]
> >    ==> 1.2) of_property_read_u32(node, "system-clock-frequency", &val)// [1]
> >    ==> 1.3) devm_get_clk_from_child(dev, dai_of_node, NULL);          // [2]

> >For the cpu routine, it first checks for clock property under cpu
> >node of simple-card, then for "system-clock-frequency" in the cpu
> >node of simple-card, and finally looks for clock property in ssi2
> >node.

> -----> dev: sound
> -----> clk node: /soc/aips-bus@02000000/spba-bus@02000000/ssi@0202c000
> -----> Clk asignment
> 
> And this clock is taken from this node. It looks like ipg clock for ssi...

This makes sense now. The devm_get_clk_from_child() in 1.3) fetched
the first clock of ssi2 -- ipg clock.

> The problem is with the "lack" of clock nodes/properties at
> 
>  			dailink_master: cpu {
>  			    sound-dai = <&ssi2>;
> 			    clock = <&SSSS>;
> 			    system-clock-frequency = <XXXX>;
>  			};

This is the right solution based on current simple-card driver. For
SSI (having two clocks), you have to specify the baud clock in the
cpu node like that. I believe this is what the simple-card designer
expected users to do since the cpu node is the first place that the
driver tries to look at.

> I think that the proper solution would be to add check for:
> 
> freq < sysclk/5 in fsl_ssi_set_dai_sysclk() and return -ENOTSUPP to
> make the simple-audo-card driver happy (and not introducing
> regressions).

As I said in the first place, adding another check in set_sysclk()
is not that essential but seems to be plausible to me. So I am okay
if you really want to have that.